Difference between revisions of "Mesh to Part/de"

From FreeCAD Documentation
Jump to navigation Jump to search
(Updating to match new version of source page)
 
(18 intermediate revisions by 2 users not shown)
Line 1: Line 1:
 
<languages/>
 
<languages/>
{{docnav/de|Topological data scripting/de|Scenegraph/de}}
 
  
== Umwandeln von Bauteilobjekten in Polygonnetze ==
+
{{TOCright}}
 +
 
 +
==Umwandeln von Teilobjekten in Polygonnetze==
 +
 
 +
Die Konvertierung von übergeordneten Objekten wie [[Part Module/de|Teil]] formen in einfachere Objekte wie [[Mesh Module/de|Polygonnetz]] ist ein sehr einfacher vorwärtsgerichteter Vorgang, bei der alle Flächen eines Teilobjekts trianguliert werden. Das Ergebnis dieser Triangulation (Tesselierung) wird dann zum Aufbau eines Polygonnetzes verwendet:
  
Die Konvertierung von übergeordneten Objekten wie [[Part Module/de|Teilformen]] in einfachere Objekte wie [[Mesh Module/de|Polygonnetze]] ist eine sehr einfache Operation, bei der alle Flächen eines Teilobjekts trianguliert werden. Das Ergebnis dieser Triangulation (Tesselierung) wird dann zum Aufbau eines Polygonnetzes verwendet: (nehmen wir an, unser Dokument enthält ein Teilobjekt)
 
 
{{Code|code=
 
{{Code|code=
#let's assume our document contains one part object
 
 
import Mesh
 
import Mesh
 +
 +
obj = FreeCADGui.Selection.getSelection()[0] # a Part object must be preselected
 +
shp = obj.Shape
 
faces = []
 
faces = []
shape = FreeCAD.ActiveDocument.ActiveObject.Shape
+
 
triangles = shape.tessellate(1) # the number represents the precision of the tessellation)
+
triangles = shp.tessellate(1) # the number represents the precision of the tessellation
 
for tri in triangles[1]:
 
for tri in triangles[1]:
 
     face = []
 
     face = []
     for i in range(3):
+
     for i in tri:
        vindex = tri[i]
+
         face.append(triangles[0][i])
         face.append(triangles[0][vindex])
 
 
     faces.append(face)
 
     faces.append(face)
 +
 
m = Mesh.Mesh(faces)
 
m = Mesh.Mesh(faces)
 
Mesh.show(m)
 
Mesh.show(m)
 
}}
 
}}
Manchmal ist die Triangulation bestimmter Flächen, die OpenCascade anbietet, ziemlich hässlich. Wenn die Fläche einen rechteckigen Parameterraum hat und keine Löcher oder andere Beschnittkurven enthält, kannst Du auch selbst ein Polygonnetz erstellen:
+
 
 +
Alternativbeispiel:
 +
 
 
{{Code|code=
 
{{Code|code=
 
import Mesh
 
import Mesh
def makeMeshFromFace(u,v,face):
+
import MeshPart
(a,b,c,d)=face.ParameterRange
 
pts=[]
 
for j in range(v):
 
for i in range(u):
 
s=1.0/(u-1)*(i*b+(u-1-i)*a)
 
t=1.0/(v-1)*(j*d+(v-1-j)*c)
 
pts.append(face.valueAt(s,t))
 
  
mesh=Mesh.Mesh()
+
obj = FreeCADGui.Selection.getSelection()[0] # a Part object must be preselected
for j in range(v-1):
+
shp = obj.Shape
for i in range(u-1):
 
mesh.addFacet(pts[u*j+i],pts[u*j+i+1],pts[u*(j+1)+i])
 
mesh.addFacet(pts[u*(j+1)+i],pts[u*j+i+1],pts[u*(j+1)+i+1])
 
  
return mesh
+
mesh = FreeCAD.ActiveDocument.addObject("Mesh::Feature", "Mesh")
 +
mesh.Mesh = MeshPart.meshFromShape(
 +
        Shape=shp,
 +
        LinearDeflection=0.01,
 +
        AngularDeflection=0.025,
 +
        Relative=False)
 
}}
 
}}
== Konvertieren von Polygonnetzen in Bauteilobjekte ==
 
  
Die Umwandlung von Polygonnetzen in Bauteilobjekte ist ein äußerst wichtiger Vorgang in der CAD Arbeit, da man sehr oft 3D Daten im Polygonnetzformat von anderen Personen erhält oder diese aus anderen Anwendungen ausgegeben werden. Polygonnetze sind sehr praktisch, um Freiformgeometrien und große visuelle Szenen darzustellen, da sie sehr leicht sind, aber für CAD bevorzugen wir im Allgemeinen übergeordnete Objekte, die viel mehr Informationen enthalten, wie z.B. die Idee des Festkörpers oder Flächen aus Kurven statt Dreiecken.
+
==Umwandlung von Polygonnetzen in Teilobjekte==
  
Die Konvertierung von Polygonnetzen in diese übergeordneten Objekte (die vom [[Part Module/de]] in FreeCAD verwaltet werden) ist keine leichte Aufgabe. Polygonnetze können aus Tausenden von Dreiecken bestehen (z.B. wenn sie von einem 3D Scanner erzeugt werden), und Körper mit derselben Anzahl von Flächen zu haben, wäre extrem schwer zu manipulieren. Daher ist es in der Regel sinnvoll, das Objekt bei der Konvertierung zu optimieren.
+
Die Umwandlung von Netzen in Teilobjekte ist ein gängiger Vorgang. Sehr oft erhälst du 3D Daten in einem Netzformat. Netze sind sehr praktisch für die Darstellung von Freiformgeometrie und großen visuellen Szenen, da sie sehr leicht sind. In FreeCAD bevorzugen wir jedoch im Allgemeinen übergeordnete Objekte, Volumenkörper, die viel mehr Informationen tragen können und gekrümmte Flächen ermöglichen.
 +
 
 +
Das Umwandeln von Netzen in diese übergeordneten Objekte (die vom [[Part-Modul]] in FreeCAD behandelt werden) ist keine einfache Operation. Netze können Tausende von Dreiecken enthalten (z.B. wenn sie von einem 3D Scanner erzeugt werden), und Körper, die aus der gleichen Anzahl von Flächen bestehen, wären extrem schwierig zu bearbeiten. Daher möchtest du im Allgemeinen das Objekt bei der Konvertierung optimieren.
  
 
FreeCAD bietet derzeit zwei Möglichkeiten, Polygonnetze in Bauteilobjekte zu konvertieren. Die erste Methode ist eine einfache, direkte Umwandlung, ohne jegliche Optimierung:
 
FreeCAD bietet derzeit zwei Möglichkeiten, Polygonnetze in Bauteilobjekte zu konvertieren. Die erste Methode ist eine einfache, direkte Umwandlung, ohne jegliche Optimierung:
 +
 
{{Code|code=
 
{{Code|code=
import Mesh,Part
+
import Mesh
 +
import Part
 +
 
 
mesh = Mesh.createTorus()
 
mesh = Mesh.createTorus()
 
shape = Part.Shape()
 
shape = Part.Shape()
shape.makeShapeFromMesh(mesh.Topology,0.05) # the second arg is the tolerance for sewing
+
shape.makeShapeFromMesh(mesh.Topology, 0.05) # the second arg is the tolerance for sewing
 
solid = Part.makeSolid(shape)
 
solid = Part.makeSolid(shape)
 
Part.show(solid)
 
Part.show(solid)
 +
}}
 +
 +
Die zweite Methode bietet die Möglichkeit, Polygonnetzfacetten koplanar zu betrachten, wenn der Winkel zwischen ihnen unter einem bestimmten Wert liegt, wodurch die Anzahl der Flächen im Endergebnis reduziert wird:
  
}}
 
Die zweite Methode bietet die Möglichkeit, Drahtmodellfacetten koplanar zu betrachten, wenn der Winkel zwischen ihnen unter einem bestimmten Wert liegt. Dies ermöglicht es, viel einfachere Formen zu bauen: (nehmen wir an, unser Dokument enthält ein Drahtmodelobjekt (mesh Objekt)).
 
 
{{Code|code=
 
{{Code|code=
# let's assume our document contains one Mesh object
+
import Mesh
import Mesh,Part,MeshPart
+
import Part
 +
import MeshPart
 +
 
 +
obj = FreeCADGui.Selection.getSelection()[0] # a Mesh object must be preselected
 +
mesh = obj.Mesh
 +
segments = mesh.getPlanarSegments(0.00001) # use rather strict tolerance here
 
faces = []
 
faces = []
mesh = App.ActiveDocument.ActiveObject.Mesh
+
 
segments = mesh.getPlanes(0.00001) # use rather strict tolerance here
 
 
 
for i in segments:
 
for i in segments:
  if len(i) > 0:
+
    if len(i) > 0:
    # a segment can have inner holes
+
        # a segment can have inner holes
    wires = MeshPart.wireFromSegment(mesh, i)
+
        wires = MeshPart.wireFromSegment(mesh, i)
    # we assume that the exterior boundary is that one with the biggest bounding box
+
        # we assume that the exterior boundary is that one with the biggest bounding box
    if len(wires) > 0:
+
        if len(wires) > 0:
        ext=None
+
            ext = None
        max_length=0
+
            max_length=0
        for i in wires:
+
            for i in wires:
          if i.BoundBox.DiagonalLength > max_length:
+
                if i.BoundBox.DiagonalLength > max_length:
              max_length = i.BoundBox.DiagonalLength
+
                    max_length = i.BoundBox.DiagonalLength
              ext = i
+
                    ext = i
  
        wires.remove(ext)
+
            wires.remove(ext)
        # all interior wires mark a hole and must reverse their orientation, otherwise Part.Face fails
+
            # all interior wires mark a hole and must reverse their orientation, otherwise Part.Face fails
        for i in wires:
+
            for i in wires:
          i.reverse()
+
                i.reverse()
  
        # make sure that the exterior wires comes as first in the list
+
            # make sure that the exterior wires comes as first in the list
        wires.insert(0, ext)
+
            wires.insert(0, ext)
        faces.append(Part.Face(wires))
+
            faces.append(Part.Face(wires))
 
 
shell=Part.Compound(faces)
 
Part.show(shell)
 
#solid = Part.Solid(Part.Shell(faces))
 
#Part.show(solid)
 
  
 +
solid = Part.Solid(Part.Shell(faces))
 +
Part.show(solid)
 
}}
 
}}
{{docnav/de|Topological data scripting/de|Scenegraph/de}}
 
 
{{Userdocnavi/de}}
 
  
[[Category:Poweruser Documentation/de]]
 
  
[[Category:Python Code/de]]
+
{{Powerdocnavi{{#translation:}}}}
 +
[[Category:Developer Documentation{{#translation:}}]]
 +
[[Category:Python Code{{#translation:}}]]
 +
{{Mesh Tools navi{{#translation:}}}}
 +
{{clear}}

Latest revision as of 21:13, 23 August 2020

Other languages:
Bahasa Indonesia • ‎Deutsch • ‎English • ‎Türkçe • ‎español • ‎français • ‎italiano • ‎polski • ‎română • ‎svenska • ‎čeština • ‎русский • ‎日本語

Umwandeln von Teilobjekten in Polygonnetze

Die Konvertierung von übergeordneten Objekten wie Teil formen in einfachere Objekte wie Polygonnetz ist ein sehr einfacher vorwärtsgerichteter Vorgang, bei der alle Flächen eines Teilobjekts trianguliert werden. Das Ergebnis dieser Triangulation (Tesselierung) wird dann zum Aufbau eines Polygonnetzes verwendet:

import Mesh

obj = FreeCADGui.Selection.getSelection()[0] # a Part object must be preselected
shp = obj.Shape
faces = []

triangles = shp.tessellate(1) # the number represents the precision of the tessellation
for tri in triangles[1]:
    face = []
    for i in tri:
        face.append(triangles[0][i])
    faces.append(face)

m = Mesh.Mesh(faces)
Mesh.show(m)

Alternativbeispiel:

import Mesh
import MeshPart

obj = FreeCADGui.Selection.getSelection()[0] # a Part object must be preselected
shp = obj.Shape

mesh = FreeCAD.ActiveDocument.addObject("Mesh::Feature", "Mesh")
mesh.Mesh = MeshPart.meshFromShape(
        Shape=shp,
        LinearDeflection=0.01,
        AngularDeflection=0.025,
        Relative=False)

Umwandlung von Polygonnetzen in Teilobjekte

Die Umwandlung von Netzen in Teilobjekte ist ein gängiger Vorgang. Sehr oft erhälst du 3D Daten in einem Netzformat. Netze sind sehr praktisch für die Darstellung von Freiformgeometrie und großen visuellen Szenen, da sie sehr leicht sind. In FreeCAD bevorzugen wir jedoch im Allgemeinen übergeordnete Objekte, Volumenkörper, die viel mehr Informationen tragen können und gekrümmte Flächen ermöglichen.

Das Umwandeln von Netzen in diese übergeordneten Objekte (die vom Part-Modul in FreeCAD behandelt werden) ist keine einfache Operation. Netze können Tausende von Dreiecken enthalten (z.B. wenn sie von einem 3D Scanner erzeugt werden), und Körper, die aus der gleichen Anzahl von Flächen bestehen, wären extrem schwierig zu bearbeiten. Daher möchtest du im Allgemeinen das Objekt bei der Konvertierung optimieren.

FreeCAD bietet derzeit zwei Möglichkeiten, Polygonnetze in Bauteilobjekte zu konvertieren. Die erste Methode ist eine einfache, direkte Umwandlung, ohne jegliche Optimierung:

import Mesh
import Part

mesh = Mesh.createTorus()
shape = Part.Shape()
shape.makeShapeFromMesh(mesh.Topology, 0.05) # the second arg is the tolerance for sewing
solid = Part.makeSolid(shape)
Part.show(solid)

Die zweite Methode bietet die Möglichkeit, Polygonnetzfacetten koplanar zu betrachten, wenn der Winkel zwischen ihnen unter einem bestimmten Wert liegt, wodurch die Anzahl der Flächen im Endergebnis reduziert wird:

import Mesh
import Part
import MeshPart

obj = FreeCADGui.Selection.getSelection()[0] # a Mesh object must be preselected
mesh = obj.Mesh
segments = mesh.getPlanarSegments(0.00001) # use rather strict tolerance here
faces = []

for i in segments:
    if len(i) > 0:
        # a segment can have inner holes
        wires = MeshPart.wireFromSegment(mesh, i)
        # we assume that the exterior boundary is that one with the biggest bounding box
        if len(wires) > 0:
            ext = None
            max_length=0
            for i in wires:
                if i.BoundBox.DiagonalLength > max_length:
                    max_length = i.BoundBox.DiagonalLength
                    ext = i

            wires.remove(ext)
            # all interior wires mark a hole and must reverse their orientation, otherwise Part.Face fails
            for i in wires:
                i.reverse()

            # make sure that the exterior wires comes as first in the list
            wires.insert(0, ext)
            faces.append(Part.Face(wires))

solid = Part.Solid(Part.Shell(faces))
Part.show(solid)